
#import <appkit/appkit.h>
@class	BibTeXObject;
@class	BibliographicFile;
@class	Preferences;


@interface BibTexView:View
{
	BibTeXObject		*theObject;
	BibTeXObject		*objWithThisKey;
	BibliographicFile	*theFile;
	Preferences			*preferences;
	List				*entryNameList;
	PopUpList			*popUpList;
	PopUpList			*popUpListNew;
	PopUpList			*popUpListString;
	PopUpList			*popUpListPreamble;
	PopUpList			*popUpListComment;
	Storage				*configList;
	Font				*theFont;

	id		inspector;
	id		keyField;
	id		keyForm;
	id		noteMatrix;
	id		popUpButton;
	id		marker;
	id		fieldEditor;

	id		entryForm;
	id		noteView;
	id		clearButton;
	id		revertButton;
	id		addButton;
	id		replaceButton;
	id		bufferedButton;
	id		positionField;
	id		leftBraceButton;
	id		rightBraceButton;
	id		scrollView;
	id		charMatrix;
	NXRect	windowFrame, minTextFrame, newWindowFrame;
	int		actualRow;	// selected NOTE-button
	int		entryType;
	unsigned int	entryFormMask, scrollViewMask, markerMask;
	BOOL	noteIsDirty;
	BOOL	isDirty;
	BOOL	textDidChange;
	BOOL	prefsDidChange;
	BOOL	isNew;
	BOOL	keyIsValid;
	BOOL	cooked;
	List	*textBufferList;

}

- displayEntry:sender;
- prefsDidChange;
- setEntry:anObject inFile:(BibliographicFile *)file;
- (void) showAllFieldsFor:(int)aType;
- clear:sender;
- addNewEntry:sender;
- newEntryFor:(BibliographicFile *)file;
- replaceEntry:sender;
- makeEntry:sender;
- insertText:(char *)txt;
- insertMacro:(char *)txt isRaw:(BOOL)isRaw;
- revert:sender;
- noteSelect:sender;
- mainBrace:sender;
- (void) drawTemplate:(int)entryType;
- specialMatrix:sender;
- showCharPanel:sender;
- setBacking:sender;
@end


/***************
	description of the various states
	
	file	object	dirty	|	revert	add	to file		replace entry
	- - - - - - - - - - - - | - - - - - - - - - - - - - - - - - - - - -
	  0		   0	  0		|	  0			0				0
	  0		   0	  X		|	  0			0				0
	  0		   X	  0		|	  		impossible state
	  0		   X	  X		|	  		impossible state
	  X		   0	  0		|	  0			0				0
	  X		   0	  X		|	  0			X (1)			0
	  X		   X	  0		|	  0			0				0
	  X		   X	  X		|	  X			X (1)			X (2) <---(3)

	(1) provided 'key' is unique (not yet in the file)
	(2) 'key' is unique or is the object's key
	(3) sets dirty to 0 after 'add...' or 'replace...'


***************/


